//
//  PetalsAroundTheRoseAppDelegate.m
//  PetalsAroundTheRose
//
//  Created by Albert Freeman on 9/15/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "PetalsAroundTheRoseAppDelegate.h"
#import "Engine.h"

@implementation PetalsAroundTheRoseAppDelegate

/*
@synthesize d1text = _d1text;
@synthesize d2text = _d2text;
@synthesize d3text = _d3text;
@synthesize d4text = _d4text;
@synthesize d5text = _d5text;
//*/
@synthesize userGuessValue = _userGuessValue;
@synthesize d1image = _d1image;
@synthesize d2image = _d2image;
@synthesize d3image = _d3image;
@synthesize d4image = _d4image;
@synthesize d5image = _d5image;
@synthesize guessResult = _guessResult;
@synthesize window = _window;

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    // Override point for customization after application launch.
    artwork = [[NSArray arrayWithObjects:
               [UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"pips1" ofType:@"PNG"]], 
               [UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"pips2" ofType:@"PNG"]], 
               [UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"pips3" ofType:@"PNG"]], 
               [UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"pips4" ofType:@"PNG"]], 
               [UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"pips5" ofType:@"PNG"]], 
               [UIImage imageWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"pips6" ofType:@"PNG"]], 
               nil] retain];
    [self rollDice:nil];
    [self.window makeKeyAndVisible];
    return YES;
}

- (void)applicationWillResignActive:(UIApplication *)application
{
    /*
     Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
     Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
     */
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    /*
     Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
     If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
     */
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    /*
     Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
     */
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    /*
     Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
     */
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    /*
     Called when the application is about to terminate.
     Save data if appropriate.
     See also applicationDidEnterBackground:.
     */
}

- (void)dealloc
{
    [_window release];
    /*
    [_d1text release];
    [_d2text release];
    [_d3text release];
    [_d4text release];
    [_d5text release];
    //*/
    [_userGuessValue release];
    [_fetchGuess release];
    [_d1image release];
    [_d2image release];
    [_d3image release];
    [_d4image release];
    [_d5image release];
    [_guessResult release];
    [artwork release];
    [super dealloc];
}

- (IBAction)fetchGuess:(id)sender {
    [_userGuessValue resignFirstResponder];
    [_userGuessValue setEnabled:NO];
    NSString *t_guess = [NSString stringWithString:[_userGuessValue text]];
    if ([t_guess intValue] != [total intValue]) {
        [_guessResult setText:@"Sorry, roll again ..."];
        [_guessResult setTextColor:[UIColor redColor]];
    } else {
        [_guessResult setText:@"Correct!"];
        [_guessResult setTextColor:[UIColor greenColor]];
    }
}

- (IBAction)rollDice:(id)sender {
    [_userGuessValue setText:@""];
    [_guessResult setText:@""];
    
    Engine *dice = [[Engine alloc] init];
    [dice roll];
    NSArray *t_dierolls = [dice dierolls];
    total = [dice total];
    [dice release];
    NSLog(@"Total %i Rolls %@\n", [total intValue], [t_dierolls description]);
    
    //[_d1text setText:[t_dierolls objectAtIndex:0]];
    [_d1image setImage:[artwork objectAtIndex:[[t_dierolls objectAtIndex:0] intValue] - 1]];
    
    //[_d2text setText:[t_dierolls objectAtIndex:1]];
    [_d2image setImage:[artwork objectAtIndex:[[t_dierolls objectAtIndex:1] intValue] - 1]];
    
    //[_d3text setText:[t_dierolls objectAtIndex:2]];
    [_d3image setImage:[artwork objectAtIndex:[[t_dierolls objectAtIndex:2] intValue] - 1]];
    
    //[_d4text setText:[t_dierolls objectAtIndex:3]];
    [_d4image setImage:[artwork objectAtIndex:[[t_dierolls objectAtIndex:3] intValue] - 1]];
    
    //[_d5text setText:[t_dierolls objectAtIndex:4]];
    [_d5image setImage:[artwork objectAtIndex:[[t_dierolls objectAtIndex:4] intValue] - 1]];
    
    [_userGuessValue setEnabled:YES];
}
@end
